%define anolis_release .0.2
# Run tests in check section
# disable for bootstrapping
%bcond_with check
#%global _unpackaged_files_terminate_build 0
%global with_debug 1

%if 0%{?with_debug}
%global debug_package   %{nil}
%endif

%global sname deepin-api

# out of memory on armv7hl
%ifarch %{arm}
%global _smp_mflags -j1
%endif

%global goipath  github.com/linuxdeepin/dde-api
%global forgeurl https://github.com/linuxdeepin/dde-api
%global tag      %{version}

Name:           dde-api
Version:        5.5.32
Release:        1%{anolis_release}%{?dist}.02
Summary:        Go-lang bingding for dde-daemon
License:        GPLv3+
URL:            https://github.com/linuxdeepin/dde-api
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  git 
BuildRequires:  libcanberra-devel
BuildRequires:  deepin-gettext-tools
BuildRequires:  librsvg2-devel
BuildRequires:  sqlite-devel
BuildRequires:  compiler(go-compiler)
BuildRequires:  go-x11-client-devel
BuildRequires:  gdk-pixbuf2-xlib-devel
BuildRequires:  kf5-kwayland-devel
BuildRequires:  poppler-glib
BuildRequires:  poppler-glib-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  alsa-lib
BuildRequires:  pulseaudio-libs-devel

BuildRequires:  gocode
#BuildRequires:  golang-github-fsnotify-fsnotify-devel
#BuildRequires:  golang-dbus
#BuildRequires:  golang-x-image-devel
#BuildRequires:  golang-github-rickb777-date-devel
#BuildRequires:  golang-github-mattn-go-sqlite3-devel
#BuildRequires:  golang-gopkg-alecthomas-kingpin-devel
#BuildRequires:  golang-github-cryptix-wav-devel
#BuildRequires:  golang-github-disintegration-imaging-devel
#BuildRequires:  golang-github-fogleman-gg-devel
#BuildRequires:  golang-github-gosexy-gettext-devel
#BuildRequires:  golang-github-nfnt-resize-devel
#BuildRequires: 	golang-github-stretchr-testify-unit-test 

BuildRequires:  go-gir-generator
BuildRequires:  go-dbus-factory-devel
BuildRequires:  go-lib-devel
BuildRequires:  libgudev-devel
%{?systemd_requires}
Requires:       deepin-desktop-base
Requires:       rfkill
Requires(pre):  shadow-utils

%description
%{summary}.

%package -n %{name}-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}-devel
%{summary}.

This package contains library source intended for
building other packages which use import path with
%{goipath} prefix.

%prep
%forgeautosetup -p1 -n %{name}-%{version}

sed -i 's|/usr/lib|%{_libexecdir}|' misc/*services/*.service \
    misc/systemd/system/deepin-shutdown-sound.service \
    lunar-calendar/main.go \
    theme_thumb/gtk/gtk.go \
    thumbnails/gtk/gtk.go

sed -i 's|PREFIX}${libdir|LIBDIR|; s|libdir|LIBDIR|' \
    Makefile adjust-grub-theme/main.go

%build
%ifarch loongarch64
export CGO_ENABLED=1
export GOOS="linux"
%endif

export GOPATH=/usr/share/gocode/:$GOPATH
%make_build

%install
for file in $(find . -iname "*.go" -o -iname "*.c" -o -iname "*.h" -o -iname "*.s"); do
    install -d -p %{buildroot}/%{gopath}/src/%{goipath}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{goipath}/$file
    echo "%{gopath}/src/%{goipath}/$file" >> devel.file-list
done
%make_install SYSTEMD_SERVICE_DIR="%{_unitdir}" LIBDIR="%{_libexecdir}"
# HOME directory for user deepin-sound-player
mkdir -p %{buildroot}%{_sharedstatedir}/deepin-sound-player

%pre
getent group deepin-sound-player >/dev/null || groupadd -r deepin-sound-player
getent passwd deepin-sound-player >/dev/null || \
    useradd -r -g deepin-sound-player -d %{_sharedstatedir}/deepin-sound-player\
    -s /sbin/nologin \
    -c "User of com.deepin.api.SoundThemePlayer.service" deepin-sound-player
exit 0

%post
%systemd_post deepin-shutdown-sound.service

%preun
%systemd_preun deepin-shutdown-sound.service

%postun
%systemd_postun_with_restart deepin-shutdown-sound.service

%files
%doc README.md
%license LICENSE
%{_bindir}/dde-open
%{_libexecdir}/%{sname}/
%{_unitdir}/*.service
%{_datadir}/dbus-1/services/*.service
%{_datadir}/dbus-1/system-services/*.service
%{_datadir}/dbus-1/system.d/*.conf
%{_datadir}/icons/hicolor/*/actions/*
%{_datadir}/dde-api/data/huangli.db
%{_datadir}/dde-api/data/huangli.version
%{_datadir}/dde-api/data/pkg_depends
%{_datadir}/dde-api/data/grub-themes/
%{_datadir}/polkit-1/actions/com.deepin.api.locale-helper.policy
%{_datadir}/polkit-1/actions/com.deepin.api.device.unblock-bluetooth-devices.policy
%{_var}/lib/polkit-1/localauthority/10-vendor.d/com.deepin.api.device.pkla
%attr(-, deepin-sound-player, deepin-sound-player) %{_sharedstatedir}/deepin-sound-player

%files -n %{name}-devel -f devel.file-list
%if 1%{?openeuler}
%{_datadir}/gocode/src/%{goipath}/*
%endif

%changelog
* Fri Jan 12 2024 yangxianzhao <yangxianzhao@uniontech.com> - 5.5.32-1.02.0.2
- rebuild for qt5-qtbase

* Wed Sep 20 2023 yangxianzhao <yangxianzhao@uniontech.com> - 5.5.32-1.02.0.1
- rebuild for qt5-qtbase-5.15.3

* Fri Dec 30 2022 liweiganga <liweiganga@uniontech.com> - 5.5.32-1.02
- chore: uniform use gocode

* Thu Dec 29 2022 liweiganga <liweiganga@uniontech.com> - 5.5.32-1.01
- chore: modify gocode source path

* Wed Dec 28 2022 liweiganga <liweiganga@uniontech.com> - 5.5.32-1
- update: update to 5.5.32

* Thu Jun 30 2022 liweiganga <liweiganga@uniontech.com> - 5.4.30-1.03
- fix: remove 'go env -w GO111MODULE=auto'

* Tue Jun 14 2022 uoser <uoser@uniontech.com> - 5.4.30-1.02
- update: update to 5.4.30-1.02
